<script setup>
import { ref } from 'vue';
import { useAuthenticationStore} from "@/stores/authenticationStore.js";
import {useRouter} from "vue-router";

const router = useRouter();
const registerStore = useAuthenticationStore();
const apiError = ref('');
const email = ref('');
const password = ref('');
const firstName = ref('');
const lastName = ref('');
const username = ref('');
const termsOfUseAccepted = ref(true);


async function registerUser()
{

  apiError.value = '';

  try
  {
    await registerStore.register( {email: email.value, password: password.value, firstName: firstName.value, lastName: lastName.value, username: username.value, termsOfUseAccepted: termsOfUseAccepted.value} )
    router.push('/login');
  }

  catch(err)
  {
    if(err.isAxiosError && err.status === 400)
    {
      apiError.value = "The data provided do not comply with the formal criteria";

    }
    if(err.isAxiosError && err.status === 409)
    {
      apiError.value = "The email address already exists";

    }
    else
    {
      apiError.value = "Unknown error occured";
    }
    console.log(apiError.value);
  }
}

const navigateToLogIn =() => {
  router.push('/login')

}

</script>

<template>
  <v-container fill-height fluid class="pa-0">
    <v-row justify="center" align="center" class="login-row">
      <v-col cols="12" sm="8" md="4">
        <v-card class="elevation-12 pa-5" color="#FFFFFF">
          <v-toolbar color="indigo-darken-1" dark flat>
            <v-toolbar-title>Register</v-toolbar-title>
          </v-toolbar>
          <v-card-text>
            <v-form  @submit.prevent="registerUser">
              <v-text-field label="E-Mail" v-model="email" outlined dense></v-text-field>
              <v-text-field label="Password" type="password" v-model="password" outlined dense></v-text-field>
              <v-text-field label="First Name" v-model="firstName" outlined dense></v-text-field>
              <v-text-field label="Last Name"  v-model="lastName" outlined dense></v-text-field>
              <v-text-field label="Username"  v-model="username" outlined dense></v-text-field>
              <v-btn color="indigo-darken-1" dark class="mt-5" block type="submit">Sign Up</v-btn>
              <v-btn color="grey" dark class="mt-3" @click="navigateToLogIn" id="BackToLogBtn">I have an account already!</v-btn>
            </v-form>
          </v-card-text>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<style scoped>
.login-row {
  min-height: 100vh;
  background: url('https://images.unsplash.com/photo-1523634921619-37ce98c1877f?q=80&w=2073&auto=format&fit=crop&ixlib=rb-4.0.3&ixid=M3wxMjA3fDB8MHxwaG90by1wYWdlfHx8fGVufDB8fHx8fA%3D%3D') center/cover no-repeat;
}

.v-card {
  max-width: 400px;
  margin-top: -100px; /* Adjust or remove this based on your design preference */
}

@media (max-height: 800px) {
  .v-card {
    margin-top: 0px;
  }
}

#BackToLogBtn{
  font-size: 10px;
  opacity: 80%;
}
</style>